import model.Tree;

import java.util.List;

/**
 * Created by user on 29.04.2017.
 */
public interface TreeWorker {
    // глубина дерева
    public int depth(Tree<?> tree);

    // содержится ли значение value в дереве
    public <T> boolean contains(Tree<T> tree, T value);

    // узел дерева содержащий значение value или null, если значение не найдено
    public <T> Tree<T> node(Tree<T> tree, T value);

    // путь от корня до узла дерева, который содержит значение value или пустой список, если в дереве нет такого значения
    public <T> List<T> path(Tree<T> tree, T value);

}
