package model;

import static model.Either.right;

/**
 * Created by user on 29.04.2017.
 */
public final class Leaf<T> extends Tree<T> {
    public Leaf(T n) {
        value = n;
    }

    @Override
    public String toString() {
        return "model.Leaf{'" + value + "'}";
    }

    @Override
    public Either<Empty, Either<Leaf, Node>> toEither() {
        return right(Either.<Leaf, Node>left(this));
    }
}
