package model;

import static model.Either.left;

/**
 * Created by user on 29.04.2017.
 */
public abstract class Tree<T> {
    public T value;

    public Tree() {
    }

    public abstract Either<Empty, Either<Leaf, Node>> toEither();

    public static final class Empty extends Tree {

        @Override
        public Either<Empty, Either<Leaf, Node>> toEither() {
            return left(this);
        }

        public Empty() {
        }
    }
}
