import java.io.*;
import java.lang.reflect.Field;

/**
 * Created by user on 29.04.2017.
 */
public class JSONWorkerImpl implements JSONWorker {
    @Override
    public String serialize(Object obj) throws IOException, IllegalAccessException {
        StringBuilder builder = new StringBuilder();
        builder.append("{\n");

        Class c = obj.getClass();
        //builder.append(c.getCanonicalName() + "\n");

        Field[] publicFields = c.getDeclaredFields();
        for (Field field : publicFields) {
            Class fieldType = field.getType();
            builder.append(field.getName() + ":" + field.get(obj) + ",\n");
        }
        builder.append("}");
        return builder.toString();
    }
}
