import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * Created by user on 29.04.2017.
 */
public class RLEncodingWorkerImpl implements RLEncodingWorker {
    @Override
    public void compress(InputStream input, OutputStream output) throws IOException {
        int c0 = input.read();
        int c;
        byte count = 1;
        while ((c = input.read()) != -1) {
            if (c0 == c) {
                count++;
            } else {
                getNum(count, output);
                output.write(c0);
                count = 1;
                c0 = c;
            }
        }
        getNum(count, output);
        output.write(c0);
    }

    private void getNum(int count, OutputStream outputStream) throws IOException {
        int d = count / 10;
        int e = count % 10;
        if (d > 0) {
            outputStream.write(48 + d);
        }
        if (e > 0) {
            outputStream.write(48 + e);
        }
    }
}
