import model.Tree;

/**
 * Created by user on 29.04.2017.
 */
public interface TreeWorker {
    // "Красивая" печать дерева, с отступами и прочим
    public void prettyPrint(Tree<?> tree);

    // Создает точную копию дерева
    public <T> Tree<T> clone(Tree<T> tree);

    // Генерация сбалансированного дерева указанной "высоты"
    public <T> Tree<T> generate(int depth, T value);

}
