package model;

import static model.Either.right;

/**
 * Created by user on 29.04.2017.
 */
public final class Node<T> extends Tree<T> {
    public Tree<T> left;
    public Tree<T> right;

    public Node(T data) {
        value = data;
    }

    public Node() {
    }

    @Override
    public String toString() {
        return "model.Node{'" + value + "'}";
    }

    @Override
    public Either<Empty, Either<Leaf, Node>> toEither() {
        return right(Either.<Leaf, Node>right(this));
    }

    public Node(Tree<T> left, Tree<T> right) {
        this.left = left;
        this.right = right;
    }
}